module spi_dri(
	sys_clk,
	clk,
	rst_n,
	user_write_data,
	user_write_valid,
	SPI_MISO,
	SPI_CLK,
	SPI_CS,
	user_ready,
	user_read_data,
	user_read_data_valid,
	SPI_MOSI);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input clk;
	input rst_n;
	input [7:0] user_write_data;
	input user_write_valid;
	input SPI_MISO;
	output SPI_CLK;
	output SPI_CS;
	output user_ready;
	output [7:0] user_read_data;
	output user_read_data_valid;
	output SPI_MOSI;

	wire sys_clk;
	wire clk;
	wire rst_n;
	wire [7:0] user_write_data;
	wire user_write_valid;
	wire SPI_MISO;
	wire SPI_CLK;
	wire SPI_CS;
	wire user_ready;
	wire [7:0] user_read_data;
	wire user_read_data_valid;
	wire SPI_MOSI;

	//----Code starts here: integrated by Robei-----
	parameter                           P_WRITE_DATA_WIDTH = 8     ;//MOSIҪ͵λĬ 8 Bit
	    parameter                           P_READ_DATA_WIDTH = 8      ;//MISOҪյλĬ 8 Bit
	    parameter                           P_CPOL = 0                 ;//ʱӼ
	    parameter                           P_CPHA = 0                 ; //ʱλ
	
	/*reg*/
	reg                                     spi_clk                    ;
	reg                                     spi_cs                     ;
	reg                                     spi_mosi                   ;
	reg                                     r_user_ready               ;
	reg                    [   P_WRITE_DATA_WIDTH - 1:0]r_user_write_data          ;
	reg                                     r_run                      ;
	reg                    [  15:0]         r_cnt                      ;
	reg                                     spi_cnt                    ;
	reg                    [   P_READ_DATA_WIDTH - 1:0]r_user_read_data           ;
	reg                                     r_user_read_data_valid     ;
	reg                                     r_run_1d                   ;
	/*wire*/
	wire                                    user_write_active          ;
	wire                                    r_run_neg                  ;
	wire                                    r_run_pos                  ;
	/*assign*/
	    assign SPI_CLK              = spi_clk;
	    assign SPI_CS               = spi_cs;
	    assign SPI_MOSI             = spi_mosi;
	    assign user_ready           = r_user_ready;
	    assign user_read_data       = r_user_read_data;
	    assign user_write_active    = user_write_valid & user_ready;    //Handshake signal
	    assign user_read_data       = r_user_read_data;
	    assign user_read_data_valid = r_user_read_data_valid;
	/*always*/
	    always @(posedge clk or negedge rst_n) begin
	        if(!rst_n)begin
	            r_user_ready <= 1'b1;
	        end
	        else if(user_write_active)begin                             //ûȷҪдݵʱû׼
	            r_user_ready <= 1'b0;
	        end
	        else if(r_run_neg)begin                                     //ݴϣûֽ׼״̬
	            r_user_ready <= 1'b1;
	        end
	        else begin
	            r_user_ready <= r_user_ready;
	        end
	    end
	
	    always @(posedge clk or negedge rst_n) begin
	        if(!rst_n)begin
	            r_user_write_data <= 8'b0;
	        end
	        else if(user_write_active)begin
	            r_user_write_data <= user_write_data;                   //û׼ϣһʱ佫ûҪд
	        end
	        else if(spi_cnt)begin
	            r_user_write_data <= r_user_write_data << 1;            //SPI_CLKر仯
	        end
	        else begin
	            r_user_write_data <= r_user_write_data;
	        end
	    end
	
	    always @(posedge clk or negedge rst_n) begin
	        if(!rst_n)begin
	            r_run <= 1'b0;
	        end
	        else if(user_write_active)begin                             //û׼ϣSPI
	            r_run <= 1'b1;
	        end
	        else if(spi_cnt && r_cnt == 16'd7)begin                     //SPI_CLKز8BitݵĴʱSPIͣ
	            r_run <= 1'b0;
	        end
	        else begin
	            r_run <= r_run;
	        end
	    end
	//ͨһģ鹤ʱڵӳ٣Ƚr_runĴ̬r_run_1d̬(r_run)׽r_runı仯
	    assign r_run_neg = ~r_run & r_run_1d ? 1'b1 : 1'b0;
	    assign r_run_pos = r_run & ~r_run_1d ? 1'b1 : 1'b0;
	    always @(posedge clk or negedge rst_n) begin
	        if(!rst_n)begin
	            r_run_1d <= 1'd0;
	        end
	        else begin
	            r_run_1d <= r_run;
	        end
	    end
	//ͨһ¼ݵĴ
	    always @(posedge clk or negedge rst_n) begin
	        if(!rst_n)begin
	            r_cnt <= 16'd0;
	        end
	        else if(spi_cnt && r_cnt == 16'd7)begin
	            r_cnt <= 16'd0;
	        end
	        else if(spi_cnt)begin
	            r_cnt <= r_cnt + 1'b1;
	        end
	        else begin
	            r_cnt <= r_cnt;
	        end
	    end
	//ͨһ׽SPI_CLKغ½ءspi_cntΪ1ʱSPI_CLKΪأspi_cntΪ0ʱSPI_CLKΪ½أ
	    always @(posedge clk or negedge rst_n) begin
	        if(!rst_n)begin
	            spi_cnt <= 1'b0;
	        end
	        else if(r_run)begin
	            spi_cnt <= spi_cnt + 1'b1;
	        end
	        else begin
	            spi_cnt <= spi_cnt;
	        end
	    end
	//ͨģ鹤ʱӶƵSPI߹ʱ
	    always @(posedge clk or negedge rst_n) begin
	        if(!rst_n)begin
	            spi_clk <= P_CPOL;
	        end
	        else if(r_run)begin
	            spi_clk <= ~spi_clk;
	        end
	        else begin
	            spi_clk <= P_CPOL;
	        end
	    end
	
	    always @(posedge clk or negedge rst_n) begin
	        if(!rst_n)begin
	            spi_cs <= 1'b1;
	        end
	        else if(user_write_active)begin//û׼ϣ򿪴豸
	            spi_cs <= 1'b0;
	        end
	        else if(!r_run)begin//SPI߹ͣرմ豸
	            spi_cs <= 1'b1;
	        end
	        else begin
	            spi_cs <= spi_cs;
	        end
	    end
	
	    always @(posedge clk or negedge rst_n) begin
	        if(!rst_n)begin
	            spi_mosi <= 1'b0;
	        end
	        else if(user_write_active)begin
	            spi_mosi <= user_write_data[P_WRITE_DATA_WIDTH - 1];    //r_user_data_i  user_data_i һϵͳʱڣԵһ޷user_data_iȡ
	        end
	        else if(spi_cnt)begin
	            spi_mosi <= r_user_write_data[P_WRITE_DATA_WIDTH - 2];//Ҫдݣһһ
	        end
	        else begin
	            spi_mosi <= spi_mosi;
	        end
	    end
	
	    always @(posedge spi_clk or negedge rst_n) begin
	        if(!rst_n)begin
	            r_user_read_data <= 1'b0;
	        end
	        else begin
	            r_user_read_data <= {r_user_read_data[P_READ_DATA_WIDTH - 2 : 0],SPI_MISO};//Ҫݣϵһһѹ
	        end
	
	    end
	
	    always @(posedge clk or negedge rst_n) begin
	        if(!rst_n)begin
	            r_user_read_data_valid <= 1'b0;
	        end
	        else if(spi_cnt && r_cnt == 16'd7)begin//ݣȫѹЧ
	            r_user_read_data_valid <= 1'b1;
	        end
	        else begin
	            r_user_read_data_valid <= 1'b0;
	        end
	    end
	
	
	
endmodule    //spi_dri

